(*==========================================================================
 *
 *  Copyright (C) 1995-1999 Microsoft Corporation. All Rights Reserved.
 *  Ported by Vadim Bodrov, TMT Development Corp.
 *
 *  File:       donuts.inc
 *  Content:    main include file
 *
 *
 ***************************************************************************)

uses Windows, Messages, MMSystem, DXLite, Input, Strings;

const
    DEF_SHOW_DELAY = 1000;


function IS_NUM(c: Char): Boolean;
begin
    Result := c in ['0'..'9'];
end;

function IS_SPACE(c: Char): Boolean;
begin
    Result := c in [#9, #10, #13, ' ', 'x'];
end;


const
    OBJ_DONUT    = 0;
    OBJ_PYRAMID  = 1;
    OBJ_CUBE     = 2;
    OBJ_SPHERE   = 3;
    OBJ_SHIP     = 4;
    OBJ_BULLET   = 5;


// program states
const
    PS_SPLASH    = 1;
    PS_ACTIVE    = 2;
    PS_BEGINREST = 3;
    PS_REST      = 4;

var
    ScreenX:   DWORD := 640;
    ScreenY:   DWORD := 480;
    ScreenBpp: DWORD := 8;

var
    MAX_SCREEN_X:  DWORD;
    MAX_SCREEN_Y:  DWORD;
    MAX_DONUT_X:   DWORD;
    MAX_DONUT_Y:   DWORD;
    MAX_PYRAMID_X: DWORD;
    MAX_PYRAMID_Y: DWORD;
    MAX_SPHERE_X:  DWORD;
    MAX_SPHERE_Y:  DWORD;
    MAX_CUBE_X:    DWORD;
    MAX_CUBE_Y:    DWORD;
    MAX_SHIP_X:    DWORD;
    MAX_SHIP_Y:    DWORD;
    MAX_BULLET_X:  DWORD;
    MAX_BULLET_Y:  DWORD;

const
    MAX_DONUT_FRAME   = 30;
    MAX_PYRAMID_FRAME = 40;
    MAX_SPHERE_FRAME  = 40;
    MAX_CUBE_FRAME    = 40;
    MAX_SHIP_FRAME    = 40;
    MAX_BULLET_FRAME  = 310;

const
// Offsets for the bullet bitmap
   BULLET_X           = 304;
   BULLET_Y           = 0;

(*
 * structures
 *)

(*
 * TDBLNODE - a node in a generic doubly-linked list
 *)
type TDblNode = record

    next:      ^TDBLNODE;             // link to next node
    prev:      ^TDBLNODE;             // link to previous node
    objtype:    SHORT;                // type of object
    posx, posy: Double;               // actual x and y position
    velx, vely: Double;               // x and y velocity (pixels/millisecond)
    frame:      Double;               // current frame
    delay:      Double;               // frame/millisecond
    src, dst:   TRect;                // source and destination rects
    surf:       PPDirectDrawSurface7; // surface containing bitmap
end;
PDblNode = ^TDblNode;

const
    Dirx: array[0..39] of Double =
(
    0.000000,
    0.156434,
    0.309017,
    0.453991,
    0.587785,
    0.707107,
    0.809017,
    0.891007,
    0.951057,
    0.987688,
    1.000000,
    0.987688,
    0.951057,
    0.891007,
    0.809017,
    0.707107,
    0.587785,
    0.453990,
    0.309017,
    0.156434,
    0.000000,
    -0.156435,
    -0.309017,
    -0.453991,
    -0.587785,
    -0.707107,
    -0.809017,
    -0.891007,
    -0.951057,
    -0.987688,
    -1.000000,
    -0.987688,
    -0.951056,
    -0.891006,
    -0.809017,
    -0.707107,
    -0.587785,
    -0.453990,
    -0.309017,
    -0.156434
);

const
    Diry: array[0..39] of Double =
(
    -1.000000,
    -0.987688,
    -0.951057,
    -0.891007,
    -0.809017,
    -0.707107,
    -0.587785,
    -0.453990,
    -0.309017,
    -0.156434,
    0.000000,
    0.156434,
    0.309017,
    0.453991,
    0.587785,
    0.707107,
    0.809017,
    0.891007,
    0.951057,
    0.987688,
    1.000000,
    0.987688,
    0.951057,
    0.891006,
    0.809017,
    0.707107,
    0.587785,
    0.453990,
    0.309017,
    0.156434,
    0.000000,
    -0.156435,
    -0.309017,
    -0.453991,
    -0.587785,
    -0.707107,
    -0.809017,
    -0.891007,
    -0.951057,
    -0.987688
);